/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CONTACT_H_
#define _CONTACT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class InformationElement;
    class Role;
    class Attendee;
    class AttendeeOrOrganizer;
    class Contact;
    class ContactGroup;
    class Email;
    class Resource;
    class DataObject;
    class Message;

}

#include "role.h"

namespace NepomukFast {

    /**
     * A Contact. A piece of data that can provide means to identify 
     * or communicate with an entity. 
     */
    class Contact : public Role
    {
    public:
        /**
         * Create a new empty and invalid Contact instance
         */
        Contact( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'key'. An encryption key attached to a contact. 
         * Inspired by the KEY property defined in RFC 2426 sec. 3.7.2 
         */
        void setKeys( const QList<DataObject>& value );

        /**
         * Add a value to property 'key'. An encryption key attached to 
         * a contact. Inspired by the KEY property defined in RFC 2426 sec. 
         * 3.7.2 
         */
        void addKey( const DataObject& value );

        /**
         * \return The URI of the property 'key'. 
         */
        static QUrl keyUri();

        /**
         * Set property 'contactUID'. A value that represents a globally 
         * unique identifier corresponding to the individual or resource 
         * associated with the Contact. An equivalent of the 'UID' property 
         * defined in RFC 2426 Sec. 3.6.7 
         */
        void setContactUIDs( const QStringList& value );

        /**
         * Add a value to property 'contactUID'. A value that represents 
         * a globally unique identifier corresponding to the individual 
         * or resource associated with the Contact. An equivalent of the 
         * 'UID' property defined in RFC 2426 Sec. 3.6.7 
         */
        void addContactUID( const QString& value );

        /**
         * Set property 'contactUID'. A value that represents a globally 
         * unique identifier corresponding to the individual or resource 
         * associated with the Contact. An equivalent of the 'UID' property 
         * defined in RFC 2426 Sec. 3.6.7 
         */
        void setContactUID( const QString& value );

        /**
         * \return The URI of the property 'contactUID'. 
         */
        static QUrl contactUIDUri();

        /**
         * Set property 'Location'. Geographical location of the contact. 
         * Inspired by the 'GEO' property specified in RFC 2426 Sec. 3.4.2 
         */
        void setLocations( const QList<Resource>& value );

        /**
         * Add a value to property 'Location'. Geographical location 
         * of the contact. Inspired by the 'GEO' property specified in 
         * RFC 2426 Sec. 3.4.2 
         */
        void addLocation( const Resource& value );

        /**
         * Set property 'Location'. Geographical location of the contact. 
         * Inspired by the 'GEO' property specified in RFC 2426 Sec. 3.4.2 
         */
        void setLocation( const Resource& value );

        /**
         * \return The URI of the property 'Location'. 
         */
        static QUrl locationUri();

        /**
         * Set property 'nickname'. A nickname of the Object represented 
         * by this Contact. This is an equivalent of the 'NICKNAME' property 
         * as defined in RFC 2426 Sec. 3.1.3. 
         */
        void setNicknames( const QStringList& value );

        /**
         * Add a value to property 'nickname'. A nickname of the Object 
         * represented by this Contact. This is an equivalent of the 'NICKNAME' 
         * property as defined in RFC 2426 Sec. 3.1.3. 
         */
        void addNickname( const QString& value );

        /**
         * \return The URI of the property 'nickname'. 
         */
        static QUrl nicknameUri();

        /**
         * Set property 'note'. A note about the object represented by 
         * this Contact. An equivalent for the 'NOTE' property defined 
         * in RFC 2426 Sec. 3.6.2 
         */
        void setNotes( const QStringList& value );

        /**
         * Add a value to property 'note'. A note about the object represented 
         * by this Contact. An equivalent for the 'NOTE' property defined 
         * in RFC 2426 Sec. 3.6.2 
         */
        void addNote( const QString& value );

        /**
         * \return The URI of the property 'note'. 
         */
        static QUrl noteUri();

        /**
         * Set property 'representative'. An object that represent an 
         * object represented by this Contact. Usually this property 
         * is used to link a Contact to an organization, to a contact to the 
         * representative of this organization the user directly interacts 
         * with. An equivalent for the 'AGENT' property defined in RFC 
         * 2426 Sec. 3.5.4 
         */
        void setRepresentatives( const QList<Contact>& value );

        /**
         * Add a value to property 'representative'. An object that represent 
         * an object represented by this Contact. Usually this property 
         * is used to link a Contact to an organization, to a contact to the 
         * representative of this organization the user directly interacts 
         * with. An equivalent for the 'AGENT' property defined in RFC 
         * 2426 Sec. 3.5.4 
         */
        void addRepresentative( const Contact& value );

        /**
         * \return The URI of the property 'representative'. 
         */
        static QUrl representativeUri();

        /**
         * Set property 'fullname'. To specify the formatted text corresponding 
         * to the name of the object the Contact represents. An equivalent 
         * of the FN property as defined in RFC 2426 Sec. 3.1.1. 
         */
        void setFullnames( const QStringList& value );

        /**
         * Add a value to property 'fullname'. To specify the formatted 
         * text corresponding to the name of the object the Contact represents. 
         * An equivalent of the FN property as defined in RFC 2426 Sec. 3.1.1. 
         */
        void addFullname( const QString& value );

        /**
         * Set property 'fullname'. To specify the formatted text corresponding 
         * to the name of the object the Contact represents. An equivalent 
         * of the FN property as defined in RFC 2426 Sec. 3.1.1. 
         */
        void setFullname( const QString& value );

        /**
         * \return The URI of the property 'fullname'. 
         */
        static QUrl fullnameUri();

        /**
         * Set property 'photo'. Photograph attached to a Contact. The 
         * DataObject referred to by this property is usually interpreted 
         * as an nfo:Image. Inspired by the PHOTO property defined in RFC 
         * 2426 sec. 3.1.4 
         */
        void setPhotos( const QList<DataObject>& value );

        /**
         * Add a value to property 'photo'. Photograph attached to a Contact. 
         * The DataObject referred to by this property is usually interpreted 
         * as an nfo:Image. Inspired by the PHOTO property defined in RFC 
         * 2426 sec. 3.1.4 
         */
        void addPhoto( const DataObject& value );

        /**
         * \return The URI of the property 'photo'. 
         */
        static QUrl photoUri();

        /**
         * Set property 'birthDate'. Birth date of the object represented 
         * by this Contact. An equivalent of the 'BDAY' property as defined 
         * in RFC 2426 Sec. 3.1.5. 
         */
        void setBirthDates( const QList<QDate>& value );

        /**
         * Add a value to property 'birthDate'. Birth date of the object 
         * represented by this Contact. An equivalent of the 'BDAY' property 
         * as defined in RFC 2426 Sec. 3.1.5. 
         */
        void addBirthDate( const QDate& value );

        /**
         * Set property 'birthDate'. Birth date of the object represented 
         * by this Contact. An equivalent of the 'BDAY' property as defined 
         * in RFC 2426 Sec. 3.1.5. 
         */
        void setBirthDate( const QDate& value );

        /**
         * \return The URI of the property 'birthDate'. 
         */
        static QUrl birthDateUri();

        /**
         * Set property 'belongsToGroup'. Links a Contact with a ContactGroup 
         * it belongs to. 
         */
        void setBelongsToGroups( const QList<ContactGroup>& value );

        /**
         * Add a value to property 'belongsToGroup'. Links a Contact with 
         * a ContactGroup it belongs to. 
         */
        void addBelongsToGroup( const ContactGroup& value );

        /**
         * \return The URI of the property 'belongsToGroup'. 
         */
        static QUrl belongsToGroupUri();

        /**
         * Set property 'sound'. Sound clip attached to a Contact. The 
         * DataObject referred to by this property is usually interpreted 
         * as an nfo:Audio. Inspired by the SOUND property defined in RFC 
         * 2425 sec. 3.6.6. 
         */
        void setSounds( const QList<DataObject>& value );

        /**
         * Add a value to property 'sound'. Sound clip attached to a Contact. 
         * The DataObject referred to by this property is usually interpreted 
         * as an nfo:Audio. Inspired by the SOUND property defined in RFC 
         * 2425 sec. 3.6.6. 
         */
        void addSound( const DataObject& value );

        /**
         * \return The URI of the property 'sound'. 
         */
        static QUrl soundUri();

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        Role toRole() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        InformationElement toInformationElement() const;



    protected:
        Contact( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
