/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "email.h"

#include "contactmedium.h"
#include "contact.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Email::Email( const QUrl &uri, const QUrl &graphUri )
  : Message( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#Email", QUrl::StrictMode) )
{
}

NepomukFast::Email::Email( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : Message( uri, graphUri, type )
{
}

void NepomukFast::Email::setTos( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#to"), (*it).uri() );
    }
}

void NepomukFast::Email::addTo( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#to"), value.uri() );
}

QUrl NepomukFast::Email::toUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#to");
}

void NepomukFast::Email::setEmailTos( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailTo"), (*it).uri() );
    }
}

void NepomukFast::Email::addEmailTo( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailTo"), value.uri() );
}

QUrl NepomukFast::Email::emailToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailTo");
}

void NepomukFast::Email::setCcs( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#cc"), (*it).uri() );
    }
}

void NepomukFast::Email::addCc( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#cc"), value.uri() );
}

QUrl NepomukFast::Email::ccUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#cc");
}

void NepomukFast::Email::setEmailCcs( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailCc"), (*it).uri() );
    }
}

void NepomukFast::Email::addEmailCc( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailCc"), value.uri() );
}

QUrl NepomukFast::Email::emailCcUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailCc");
}

void NepomukFast::Email::setBccs( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#bcc"), (*it).uri() );
    }
}

void NepomukFast::Email::addBcc( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#bcc"), value.uri() );
}

QUrl NepomukFast::Email::bccUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#bcc");
}

void NepomukFast::Email::setEmailBccs( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailBcc"), (*it).uri() );
    }
}

void NepomukFast::Email::addEmailBcc( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailBcc"), value.uri() );
}

QUrl NepomukFast::Email::emailBccUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#emailBcc");
}

void NepomukFast::Email::setContentMimeTypes( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#contentMimeType"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Email::addContentMimeType( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#contentMimeType"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Email::setContentMimeType( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#contentMimeType"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Email::contentMimeTypeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#contentMimeType");
}


