/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _EMAIL_H_
#define _EMAIL_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Contact;
    class ContactMedium;

}

#include "message.h"

namespace NepomukFast {

    /**
     * An email. 
     */
    class Email : public Message
    {
    public:
        /**
         * Create a new empty and invalid Email instance
         */
        Email( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'to'. deprecated in favor of nmo:emailTo 
         */
        void setTos( const QList<Contact>& value );

        /**
         * Add a value to property 'to'. deprecated in favor of nmo:emailTo 
         */
        void addTo( const Contact& value );

        /**
         * \return The URI of the property 'to'. 
         */
        static QUrl toUri();

        /**
         * Set property 'emailTo'. The primary intended recipient of 
         * an email. 
         */
        void setEmailTos( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'emailTo'. The primary intended recipient 
         * of an email. 
         */
        void addEmailTo( const ContactMedium& value );

        /**
         * \return The URI of the property 'emailTo'. 
         */
        static QUrl emailToUri();

        /**
         * Set property 'cc'. deprecated in favor of nmo:emailCc 
         */
        void setCcs( const QList<Contact>& value );

        /**
         * Add a value to property 'cc'. deprecated in favor of nmo:emailCc 
         */
        void addCc( const Contact& value );

        /**
         * \return The URI of the property 'cc'. 
         */
        static QUrl ccUri();

        /**
         * Set property 'emailCc'. A Contact that is to receive a cc of the 
         * email. A cc (carbon copy) is a copy of an email message whose recipient 
         * appears on the recipient list, so that all other recipients 
         * are aware of it. 
         */
        void setEmailCcs( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'emailCc'. A Contact that is to receive 
         * a cc of the email. A cc (carbon copy) is a copy of an email message 
         * whose recipient appears on the recipient list, so that all other 
         * recipients are aware of it. 
         */
        void addEmailCc( const ContactMedium& value );

        /**
         * \return The URI of the property 'emailCc'. 
         */
        static QUrl emailCcUri();

        /**
         * Set property 'bcc'. deprecated in favor of nmo:emailBcc 
         */
        void setBccs( const QList<Contact>& value );

        /**
         * Add a value to property 'bcc'. deprecated in favor of nmo:emailBcc 
         */
        void addBcc( const Contact& value );

        /**
         * \return The URI of the property 'bcc'. 
         */
        static QUrl bccUri();

        /**
         * Set property 'emailBcc'. A Contact that is to receive a bcc of 
         * the email. A Bcc (blind carbon copy) is a copy of an email message 
         * sent to a recipient whose email address does not appear in the 
         * message. 
         */
        void setEmailBccs( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'emailBcc'. A Contact that is to receive 
         * a bcc of the email. A Bcc (blind carbon copy) is a copy of an email 
         * message sent to a recipient whose email address does not appear 
         * in the message. 
         */
        void addEmailBcc( const ContactMedium& value );

        /**
         * \return The URI of the property 'emailBcc'. 
         */
        static QUrl emailBccUri();

        /**
         * Set property 'contentMimeType'. Key used to store the MIME 
         * type of the content of an object when it is different from the 
         * object's main MIME type. This value can be used, for example, 
         * to model an e-mail message whose mime type is"message/rfc822", 
         * but whose content has type "text/html". If not specified, the 
         * MIME type of the content defaults to the value specified by the 
         * 'mimeType' property. 
         */
        void setContentMimeTypes( const QStringList& value );

        /**
         * Add a value to property 'contentMimeType'. Key used to store 
         * the MIME type of the content of an object when it is different 
         * from the object's main MIME type. This value can be used, for 
         * example, to model an e-mail message whose mime type is"message/rfc822", 
         * but whose content has type "text/html". If not specified, the 
         * MIME type of the content defaults to the value specified by the 
         * 'mimeType' property. 
         */
        void addContentMimeType( const QString& value );

        /**
         * Set property 'contentMimeType'. Key used to store the MIME 
         * type of the content of an object when it is different from the 
         * object's main MIME type. This value can be used, for example, 
         * to model an e-mail message whose mime type is"message/rfc822", 
         * but whose content has type "text/html". If not specified, the 
         * MIME type of the content defaults to the value specified by the 
         * 'mimeType' property. 
         */
        void setContentMimeType( const QString& value );

        /**
         * \return The URI of the property 'contentMimeType'. 
         */
        static QUrl contentMimeTypeUri();



    protected:
        Email( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
