/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "message.h"

#include "contactmedium.h"
#include "contact.h"
#include "messageheader.h"
#include "message.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Message::Message( const QUrl &uri, const QUrl &graphUri )
  : InformationElement( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#Message", QUrl::StrictMode) )
{
}

NepomukFast::Message::Message( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : InformationElement( uri, graphUri, type )
{
}

void NepomukFast::Message::setMessageSubjects( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSubject"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addMessageSubject( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSubject"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Message::setMessageSubject( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSubject"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::messageSubjectUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSubject");
}

void NepomukFast::Message::setReferenceses( const QList<NepomukFast::Message>& value )
{
    for( QList<Message>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#references"), (*it).uri() );
    }
}

void NepomukFast::Message::addReferences( const NepomukFast::Message& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#references"), value.uri() );
}

QUrl NepomukFast::Message::referencesUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#references");
}

void NepomukFast::Message::setFroms( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#from"), (*it).uri() );
    }
}

void NepomukFast::Message::addFrom( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#from"), value.uri() );
}

QUrl NepomukFast::Message::fromUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#from");
}

void NepomukFast::Message::setMessageFroms( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageFrom"), (*it).uri() );
    }
}

void NepomukFast::Message::addMessageFrom( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageFrom"), value.uri() );
}

void NepomukFast::Message::setMessageFrom( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageFrom"), value.uri() );
}

QUrl NepomukFast::Message::messageFromUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageFrom");
}

void NepomukFast::Message::setIsReads( const QList<bool>& value )
{
    for( QList<bool>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#isRead"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addIsRead( const bool& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#isRead"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Message::setIsRead( const bool& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#isRead"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::isReadUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#isRead");
}

void NepomukFast::Message::setMessageHeaders( const QList<NepomukFast::MessageHeader>& value )
{
    for( QList<MessageHeader>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageHeader"), (*it).uri() );
    }
}

void NepomukFast::Message::addMessageHeader( const NepomukFast::MessageHeader& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageHeader"), value.uri() );
}

void NepomukFast::Message::setMessageHeader( const NepomukFast::MessageHeader& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageHeader"), value.uri() );
}

QUrl NepomukFast::Message::messageHeaderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageHeader");
}

void NepomukFast::Message::setPrimaryRecipients( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryRecipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addPrimaryRecipient( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryRecipient"), value.uri() );
}

QUrl NepomukFast::Message::primaryRecipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryRecipient");
}

void NepomukFast::Message::setPrimaryMessageRecipients( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryMessageRecipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addPrimaryMessageRecipient( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryMessageRecipient"), value.uri() );
}

QUrl NepomukFast::Message::primaryMessageRecipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#primaryMessageRecipient");
}

void NepomukFast::Message::setInReplyTos( const QList<NepomukFast::Message>& value )
{
    for( QList<Message>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#inReplyTo"), (*it).uri() );
    }
}

void NepomukFast::Message::addInReplyTo( const NepomukFast::Message& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#inReplyTo"), value.uri() );
}

void NepomukFast::Message::setInReplyTo( const NepomukFast::Message& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#inReplyTo"), value.uri() );
}

QUrl NepomukFast::Message::inReplyToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#inReplyTo");
}

void NepomukFast::Message::setMessageIds( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageId"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addMessageId( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageId"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::messageIdUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageId");
}

void NepomukFast::Message::setReceivedDates( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#receivedDate"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addReceivedDate( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#receivedDate"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Message::setReceivedDate( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#receivedDate"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::receivedDateUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#receivedDate");
}

void NepomukFast::Message::setReplyTos( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#replyTo"), (*it).uri() );
    }
}

void NepomukFast::Message::addReplyTo( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#replyTo"), value.uri() );
}

QUrl NepomukFast::Message::replyToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#replyTo");
}

void NepomukFast::Message::setMessageReplyTos( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageReplyTo"), (*it).uri() );
    }
}

void NepomukFast::Message::addMessageReplyTo( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageReplyTo"), value.uri() );
}

void NepomukFast::Message::setMessageReplyTo( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageReplyTo"), value.uri() );
}

QUrl NepomukFast::Message::messageReplyToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageReplyTo");
}

void NepomukFast::Message::setRecipients( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#recipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addRecipient( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#recipient"), value.uri() );
}

QUrl NepomukFast::Message::recipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#recipient");
}

void NepomukFast::Message::setMessageRecipients( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageRecipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addMessageRecipient( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageRecipient"), value.uri() );
}

QUrl NepomukFast::Message::messageRecipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageRecipient");
}

void NepomukFast::Message::setSecondaryRecipients( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryRecipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addSecondaryRecipient( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryRecipient"), value.uri() );
}

QUrl NepomukFast::Message::secondaryRecipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryRecipient");
}

void NepomukFast::Message::setSecondaryMessageRecipients( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryMessageRecipient"), (*it).uri() );
    }
}

void NepomukFast::Message::addSecondaryMessageRecipient( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryMessageRecipient"), value.uri() );
}

QUrl NepomukFast::Message::secondaryMessageRecipientUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#secondaryMessageRecipient");
}

void NepomukFast::Message::setPlainTextMessageContents( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#plainTextMessageContent"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addPlainTextMessageContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#plainTextMessageContent"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::plainTextMessageContentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#plainTextMessageContent");
}

void NepomukFast::Message::setHtmlMessageContents( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#htmlMessageContent"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addHtmlMessageContent( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#htmlMessageContent"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::htmlMessageContentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#htmlMessageContent");
}

void NepomukFast::Message::setSentDates( const QList<QDateTime>& value )
{
    for( QList<QDateTime>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sentDate"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Message::addSentDate( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sentDate"), Soprano::LiteralValue( value ) );
}

void NepomukFast::Message::setSentDate( const QDateTime& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sentDate"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Message::sentDateUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sentDate");
}

void NepomukFast::Message::setSenders( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sender"), (*it).uri() );
    }
}

void NepomukFast::Message::addSender( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sender"), value.uri() );
}

QUrl NepomukFast::Message::senderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#sender");
}

void NepomukFast::Message::setMessageSenders( const QList<NepomukFast::ContactMedium>& value )
{
    for( QList<ContactMedium>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSender"), (*it).uri() );
    }
}

void NepomukFast::Message::addMessageSender( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSender"), value.uri() );
}

void NepomukFast::Message::setMessageSender( const NepomukFast::ContactMedium& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSender"), value.uri() );
}

QUrl NepomukFast::Message::messageSenderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#messageSender");
}

void NepomukFast::Message::setAttachments( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#hasAttachment"), (*it).uri() );
    }
}

void NepomukFast::Message::addAttachment( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#hasAttachment"), value.uri() );
}

QUrl NepomukFast::Message::attachmentUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nmo#hasAttachment");
}


