/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _MESSAGE_H_
#define _MESSAGE_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class MessageHeader;
    class Contact;
    class Resource;
    class Message;
    class ContactMedium;

}

#include "informationelement.h"

namespace NepomukFast {

    /**
     * A message. Could be an email, instant messanging message, SMS 
     * message etc. 
     */
    class Message : public InformationElement
    {
    public:
        /**
         * Create a new empty and invalid Message instance
         */
        Message( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'messageSubject'. The subject of a message 
         */
        void setMessageSubjects( const QStringList& value );

        /**
         * Add a value to property 'messageSubject'. The subject of a message 
         */
        void addMessageSubject( const QString& value );

        /**
         * Set property 'messageSubject'. The subject of a message 
         */
        void setMessageSubject( const QString& value );

        /**
         * \return The URI of the property 'messageSubject'. 
         */
        static QUrl messageSubjectUri();

        /**
         * Set property 'references'. Signifies that a message references 
         * another message. This property is a generic one. See RFC 2822 
         * Sec. 3.6.4 
         */
        void setReferenceses( const QList<Message>& value );

        /**
         * Add a value to property 'references'. Signifies that a message 
         * references another message. This property is a generic one. 
         * See RFC 2822 Sec. 3.6.4 
         */
        void addReferences( const Message& value );

        /**
         * \return The URI of the property 'references'. 
         */
        static QUrl referencesUri();

        /**
         * Set property 'from'. deprecated in favor of nmo:messageFrom 
         */
        void setFroms( const QList<Contact>& value );

        /**
         * Add a value to property 'from'. deprecated in favor of nmo:messageFrom 
         */
        void addFrom( const Contact& value );

        /**
         * \return The URI of the property 'from'. 
         */
        static QUrl fromUri();

        /**
         * Set property 'messageFrom'. The sender of the message 
         */
        void setMessageFroms( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'messageFrom'. The sender of the message 
         */
        void addMessageFrom( const ContactMedium& value );

        /**
         * Set property 'messageFrom'. The sender of the message 
         */
        void setMessageFrom( const ContactMedium& value );

        /**
         * \return The URI of the property 'messageFrom'. 
         */
        static QUrl messageFromUri();

        /**
         * Set property 'isRead'. A flag that states the fact that a MailboxDataObject 
         * has been read. 
         */
        void setIsReads( const QList<bool>& value );

        /**
         * Add a value to property 'isRead'. A flag that states the fact 
         * that a MailboxDataObject has been read. 
         */
        void addIsRead( const bool& value );

        /**
         * Set property 'isRead'. A flag that states the fact that a MailboxDataObject 
         * has been read. 
         */
        void setIsRead( const bool& value );

        /**
         * \return The URI of the property 'isRead'. 
         */
        static QUrl isReadUri();

        /**
         * Set property 'messageHeader'. Links the message wiith an arbitrary 
         * message header. 
         */
        void setMessageHeaders( const QList<MessageHeader>& value );

        /**
         * Add a value to property 'messageHeader'. Links the message 
         * wiith an arbitrary message header. 
         */
        void addMessageHeader( const MessageHeader& value );

        /**
         * Set property 'messageHeader'. Links the message wiith an arbitrary 
         * message header. 
         */
        void setMessageHeader( const MessageHeader& value );

        /**
         * \return The URI of the property 'messageHeader'. 
         */
        static QUrl messageHeaderUri();

        /**
         * Set property 'primaryRecipient'. deprecated in favor of primaryMessageRecipient 
         */
        void setPrimaryRecipients( const QList<Contact>& value );

        /**
         * Add a value to property 'primaryRecipient'. deprecated in 
         * favor of primaryMessageRecipient 
         */
        void addPrimaryRecipient( const Contact& value );

        /**
         * \return The URI of the property 'primaryRecipient'. 
         */
        static QUrl primaryRecipientUri();

        /**
         * Set property 'primaryMessageRecipient'. The primary intended 
         * recipient of a message. 
         */
        void setPrimaryMessageRecipients( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'primaryMessageRecipient'. The primary 
         * intended recipient of a message. 
         */
        void addPrimaryMessageRecipient( const ContactMedium& value );

        /**
         * \return The URI of the property 'primaryMessageRecipient'. 
         */
        static QUrl primaryMessageRecipientUri();

        /**
         * Set property 'inReplyTo'. Signifies that a message is a reply 
         * to another message. This feature is commonly used to link messages 
         * into conversations. Note that it is more specific than nmo:references. 
         * See RFC 2822 sec. 3.6.4 
         */
        void setInReplyTos( const QList<Message>& value );

        /**
         * Add a value to property 'inReplyTo'. Signifies that a message 
         * is a reply to another message. This feature is commonly used 
         * to link messages into conversations. Note that it is more specific 
         * than nmo:references. See RFC 2822 sec. 3.6.4 
         */
        void addInReplyTo( const Message& value );

        /**
         * Set property 'inReplyTo'. Signifies that a message is a reply 
         * to another message. This feature is commonly used to link messages 
         * into conversations. Note that it is more specific than nmo:references. 
         * See RFC 2822 sec. 3.6.4 
         */
        void setInReplyTo( const Message& value );

        /**
         * \return The URI of the property 'inReplyTo'. 
         */
        static QUrl inReplyToUri();

        /**
         * Set property 'messageId'. An identifier of a message. This 
         * property has been inspired by the message-id property defined 
         * in RFC 2822, Sec. 3.6.4. It should be used for all kinds of identifiers 
         * used by various messaging applications to connect multiple 
         * messages into conversations. For email messageids, values 
         * are according to RFC2822/sec 3.6.4 and the literal value in 
         * RDF must include the brackets. 
         */
        void setMessageIds( const QStringList& value );

        /**
         * Add a value to property 'messageId'. An identifier of a message. 
         * This property has been inspired by the message-id property 
         * defined in RFC 2822, Sec. 3.6.4. It should be used for all kinds 
         * of identifiers used by various messaging applications to connect 
         * multiple messages into conversations. For email messageids, 
         * values are according to RFC2822/sec 3.6.4 and the literal value 
         * in RDF must include the brackets. 
         */
        void addMessageId( const QString& value );

        /**
         * \return The URI of the property 'messageId'. 
         */
        static QUrl messageIdUri();

        /**
         * Set property 'receivedDate'. Date when this message was received. 
         */
        void setReceivedDates( const QList<QDateTime>& value );

        /**
         * Add a value to property 'receivedDate'. Date when this message 
         * was received. 
         */
        void addReceivedDate( const QDateTime& value );

        /**
         * Set property 'receivedDate'. Date when this message was received. 
         */
        void setReceivedDate( const QDateTime& value );

        /**
         * \return The URI of the property 'receivedDate'. 
         */
        static QUrl receivedDateUri();

        /**
         * Set property 'replyTo'. deprecated in favor of nmo:messageReplyTo 
         */
        void setReplyTos( const QList<Contact>& value );

        /**
         * Add a value to property 'replyTo'. deprecated in favor of nmo:messageReplyTo 
         */
        void addReplyTo( const Contact& value );

        /**
         * \return The URI of the property 'replyTo'. 
         */
        static QUrl replyToUri();

        /**
         * Set property 'messageReplyTo'. An address where the reply 
         * should be sent. 
         */
        void setMessageReplyTos( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'messageReplyTo'. An address where 
         * the reply should be sent. 
         */
        void addMessageReplyTo( const ContactMedium& value );

        /**
         * Set property 'messageReplyTo'. An address where the reply 
         * should be sent. 
         */
        void setMessageReplyTo( const ContactMedium& value );

        /**
         * \return The URI of the property 'messageReplyTo'. 
         */
        static QUrl messageReplyToUri();

        /**
         * Set property 'recipient'. deprecated in favor of nmo:messageRecipient 
         */
        void setRecipients( const QList<Contact>& value );

        /**
         * Add a value to property 'recipient'. deprecated in favor of 
         * nmo:messageRecipient 
         */
        void addRecipient( const Contact& value );

        /**
         * \return The URI of the property 'recipient'. 
         */
        static QUrl recipientUri();

        /**
         * Set property 'messageRecipient'. A common superproperty 
         * for all properties that link a message with its recipients. 
         * Please don't use this property directly. 
         */
        void setMessageRecipients( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'messageRecipient'. A common superproperty 
         * for all properties that link a message with its recipients. 
         * Please don't use this property directly. 
         */
        void addMessageRecipient( const ContactMedium& value );

        /**
         * \return The URI of the property 'messageRecipient'. 
         */
        static QUrl messageRecipientUri();

        /**
         * Set property 'secondaryRecipient'. deprecated in favor of 
         * nmo:secondaryMessageRecipient 
         */
        void setSecondaryRecipients( const QList<Contact>& value );

        /**
         * Add a value to property 'secondaryRecipient'. deprecated 
         * in favor of nmo:secondaryMessageRecipient 
         */
        void addSecondaryRecipient( const Contact& value );

        /**
         * \return The URI of the property 'secondaryRecipient'. 
         */
        static QUrl secondaryRecipientUri();

        /**
         * Set property 'secondaryMessageRecipient'. A superproperty 
         * for all "additional" recipients of a message. 
         */
        void setSecondaryMessageRecipients( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'secondaryMessageRecipient'. A superproperty 
         * for all "additional" recipients of a message. 
         */
        void addSecondaryMessageRecipient( const ContactMedium& value );

        /**
         * \return The URI of the property 'secondaryMessageRecipient'. 
         */
        static QUrl secondaryMessageRecipientUri();

        /**
         * Set property 'plainTextMessageContent'. Plain text representation 
         * of the body of the message. For multipart messages, all parts 
         * are concatenated into the value of this property. Attachments, 
         * whose mimeTypes are different from text/plain or message/rfc822 
         * are considered separate DataObjects and are therefore not 
         * included in the value of this property. 
         */
        void setPlainTextMessageContents( const QStringList& value );

        /**
         * Add a value to property 'plainTextMessageContent'. Plain 
         * text representation of the body of the message. For multipart 
         * messages, all parts are concatenated into the value of this 
         * property. Attachments, whose mimeTypes are different from 
         * text/plain or message/rfc822 are considered separate DataObjects 
         * and are therefore not included in the value of this property. 
         */
        void addPlainTextMessageContent( const QString& value );

        /**
         * \return The URI of the property 'plainTextMessageContent'. 
         */
        static QUrl plainTextMessageContentUri();

        /**
         * Set property 'htmlMessageContent'. HTML representation 
         * of the body of the message. For multipart messages, all parts 
         * are concatenated into the value of this property. Attachments, 
         * whose mimeTypes are different from text/plain or message/rfc822 
         * are considered separate DataObjects and are therefore not 
         * included in the value of this property. 
         */
        void setHtmlMessageContents( const QStringList& value );

        /**
         * Add a value to property 'htmlMessageContent'. HTML representation 
         * of the body of the message. For multipart messages, all parts 
         * are concatenated into the value of this property. Attachments, 
         * whose mimeTypes are different from text/plain or message/rfc822 
         * are considered separate DataObjects and are therefore not 
         * included in the value of this property. 
         */
        void addHtmlMessageContent( const QString& value );

        /**
         * \return The URI of the property 'htmlMessageContent'. 
         */
        static QUrl htmlMessageContentUri();

        /**
         * Set property 'sentDate'. Date when this message was sent. 
         */
        void setSentDates( const QList<QDateTime>& value );

        /**
         * Add a value to property 'sentDate'. Date when this message was 
         * sent. 
         */
        void addSentDate( const QDateTime& value );

        /**
         * Set property 'sentDate'. Date when this message was sent. 
         */
        void setSentDate( const QDateTime& value );

        /**
         * \return The URI of the property 'sentDate'. 
         */
        static QUrl sentDateUri();

        /**
         * Set property 'sender'. deprecated in favor of nmo:messageSender 
         */
        void setSenders( const QList<Contact>& value );

        /**
         * Add a value to property 'sender'. deprecated in favor of nmo:messageSender 
         */
        void addSender( const Contact& value );

        /**
         * \return The URI of the property 'sender'. 
         */
        static QUrl senderUri();

        /**
         * Set property 'messageSender'. The person or agent submitting 
         * the message to the network, if other from the one given with the 
         * nmo:from property. Defined in RFC 822 sec. 4.4.2 
         */
        void setMessageSenders( const QList<ContactMedium>& value );

        /**
         * Add a value to property 'messageSender'. The person or agent 
         * submitting the message to the network, if other from the one 
         * given with the nmo:from property. Defined in RFC 822 sec. 4.4.2 
         */
        void addMessageSender( const ContactMedium& value );

        /**
         * Set property 'messageSender'. The person or agent submitting 
         * the message to the network, if other from the one given with the 
         * nmo:from property. Defined in RFC 822 sec. 4.4.2 
         */
        void setMessageSender( const ContactMedium& value );

        /**
         * \return The URI of the property 'messageSender'. 
         */
        static QUrl messageSenderUri();

        /**
         * Set property 'Attachment'. Links a message with files that 
         * were sent as attachments. 
         */
        void setAttachments( const QList<Resource>& value );

        /**
         * Add a value to property 'Attachment'. Links a message with files 
         * that were sent as attachments. 
         */
        void addAttachment( const Resource& value );

        /**
         * \return The URI of the property 'Attachment'. 
         */
        static QUrl attachmentUri();



    protected:
        Message( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
