/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _POSTALADDRESS_H_
#define _POSTALADDRESS_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Role;
    class Resource;

}

#include "contactmedium.h"

namespace NepomukFast {

    /**
     * A postal address. A class aggregating the various parts of a 
     * value for the 'ADR' property as defined in RFC 2426 Sec. 3.2.1. 
     */
    class PostalAddress : public ContactMedium
    {
    public:
        /**
         * Create a new empty and invalid PostalAddress instance
         */
        PostalAddress( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'region'. Region. Inspired by the fifth part of 
         * the value of the 'ADR' property as defined in RFC 2426, sec. 3.2.1 
         */
        void setRegions( const QStringList& value );

        /**
         * Add a value to property 'region'. Region. Inspired by the fifth 
         * part of the value of the 'ADR' property as defined in RFC 2426, 
         * sec. 3.2.1 
         */
        void addRegion( const QString& value );

        /**
         * Set property 'region'. Region. Inspired by the fifth part of 
         * the value of the 'ADR' property as defined in RFC 2426, sec. 3.2.1 
         */
        void setRegion( const QString& value );

        /**
         * \return The URI of the property 'region'. 
         */
        static QUrl regionUri();

        /**
         * Set property 'country'. A part of an address specyfing the country. 
         * Inspired by the seventh part of the value of the 'ADR' property 
         * as defined in RFC 2426, sec. 3.2.1 
         */
        void setCountrys( const QStringList& value );

        /**
         * Add a value to property 'country'. A part of an address specyfing 
         * the country. Inspired by the seventh part of the value of the 
         * 'ADR' property as defined in RFC 2426, sec. 3.2.1 
         */
        void addCountry( const QString& value );

        /**
         * Set property 'country'. A part of an address specyfing the country. 
         * Inspired by the seventh part of the value of the 'ADR' property 
         * as defined in RFC 2426, sec. 3.2.1 
         */
        void setCountry( const QString& value );

        /**
         * \return The URI of the property 'country'. 
         */
        static QUrl countryUri();

        /**
         * Set property 'extendedAddress'. An extended part of an address. 
         * This field might be used to express parts of an address that aren't 
         * include in the name of the Contact but also aren't part of the 
         * actual location. Usually the streed address and following 
         * fields are enough for a postal letter to arrive. Examples may 
         * include ('University of California Campus building 45', 'Sears 
         * Tower 34th floor' etc.) Inspired by the second part of the value 
         * of the 'ADR' property as defined in RFC 2426, sec. 3.2.1 
         */
        void setExtendedAddresses( const QStringList& value );

        /**
         * Add a value to property 'extendedAddress'. An extended part 
         * of an address. This field might be used to express parts of an 
         * address that aren't include in the name of the Contact but also 
         * aren't part of the actual location. Usually the streed address 
         * and following fields are enough for a postal letter to arrive. 
         * Examples may include ('University of California Campus building 
         * 45', 'Sears Tower 34th floor' etc.) Inspired by the second part 
         * of the value of the 'ADR' property as defined in RFC 2426, sec. 
         * 3.2.1 
         */
        void addExtendedAddress( const QString& value );

        /**
         * Set property 'extendedAddress'. An extended part of an address. 
         * This field might be used to express parts of an address that aren't 
         * include in the name of the Contact but also aren't part of the 
         * actual location. Usually the streed address and following 
         * fields are enough for a postal letter to arrive. Examples may 
         * include ('University of California Campus building 45', 'Sears 
         * Tower 34th floor' etc.) Inspired by the second part of the value 
         * of the 'ADR' property as defined in RFC 2426, sec. 3.2.1 
         */
        void setExtendedAddress( const QString& value );

        /**
         * \return The URI of the property 'extendedAddress'. 
         */
        static QUrl extendedAddressUri();

        /**
         * Set property 'addressLocation'. The geographical location 
         * of a postal address. 
         */
        void setAddressLocations( const QList<Resource>& value );

        /**
         * Add a value to property 'addressLocation'. The geographical 
         * location of a postal address. 
         */
        void addAddressLocation( const Resource& value );

        /**
         * Set property 'addressLocation'. The geographical location 
         * of a postal address. 
         */
        void setAddressLocation( const Resource& value );

        /**
         * \return The URI of the property 'addressLocation'. 
         */
        static QUrl addressLocationUri();

        /**
         * Set property 'streetAddress'. The streed address. Inspired 
         * by the third part of the value of the 'ADR' property as defined 
         * in RFC 2426, sec. 3.2.1 
         */
        void setStreetAddresses( const QStringList& value );

        /**
         * Add a value to property 'streetAddress'. The streed address. 
         * Inspired by the third part of the value of the 'ADR' property 
         * as defined in RFC 2426, sec. 3.2.1 
         */
        void addStreetAddress( const QString& value );

        /**
         * Set property 'streetAddress'. The streed address. Inspired 
         * by the third part of the value of the 'ADR' property as defined 
         * in RFC 2426, sec. 3.2.1 
         */
        void setStreetAddress( const QString& value );

        /**
         * \return The URI of the property 'streetAddress'. 
         */
        static QUrl streetAddressUri();

        /**
         * Set property 'postalcode'. Postal Code. Inspired by the sixth 
         * part of the value of the 'ADR' property as defined in RFC 2426, 
         * sec. 3.2.1 
         */
        void setPostalcodes( const QStringList& value );

        /**
         * Add a value to property 'postalcode'. Postal Code. Inspired 
         * by the sixth part of the value of the 'ADR' property as defined 
         * in RFC 2426, sec. 3.2.1 
         */
        void addPostalcode( const QString& value );

        /**
         * Set property 'postalcode'. Postal Code. Inspired by the sixth 
         * part of the value of the 'ADR' property as defined in RFC 2426, 
         * sec. 3.2.1 
         */
        void setPostalcode( const QString& value );

        /**
         * \return The URI of the property 'postalcode'. 
         */
        static QUrl postalcodeUri();

        /**
         * Set property 'locality'. Locality or City. Inspired by the 
         * fourth part of the value of the 'ADR' property as defined in RFC 
         * 2426, sec. 3.2.1 
         */
        void setLocalitys( const QStringList& value );

        /**
         * Add a value to property 'locality'. Locality or City. Inspired 
         * by the fourth part of the value of the 'ADR' property as defined 
         * in RFC 2426, sec. 3.2.1 
         */
        void addLocality( const QString& value );

        /**
         * Set property 'locality'. Locality or City. Inspired by the 
         * fourth part of the value of the 'ADR' property as defined in RFC 
         * 2426, sec. 3.2.1 
         */
        void setLocality( const QString& value );

        /**
         * \return The URI of the property 'locality'. 
         */
        static QUrl localityUri();

        /**
         * Set property 'pobox'. Post office box. This is the first part 
         * of the value of the 'ADR' property as defined in RFC 2426, sec. 
         * 3.2.1 
         */
        void setPoboxs( const QStringList& value );

        /**
         * Add a value to property 'pobox'. Post office box. This is the 
         * first part of the value of the 'ADR' property as defined in RFC 
         * 2426, sec. 3.2.1 
         */
        void addPobox( const QString& value );

        /**
         * Set property 'pobox'. Post office box. This is the first part 
         * of the value of the 'ADR' property as defined in RFC 2426, sec. 
         * 3.2.1 
         */
        void setPobox( const QString& value );

        /**
         * \return The URI of the property 'pobox'. 
         */
        static QUrl poboxUri();



    protected:
        PostalAddress( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
